regina::SpiralSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a spiralled solid torus in a triangulation. More...

`#include <subcomplex/spiralsolidtorus.h>`

Inheritance diagram for regina::SpiralSolidTorus:

## Public Member Functions

virtual | ~SpiralSolidTorus ()
| Destroys this spiralled solid torus. More...
SpiralSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
size_t | size () const
| Returns the number of tetrahedra in this spiralled solid torus. More...
Tetrahedron< 3 > * | tetrahedron (size_t index) const
| Returns the requested tetrahedron in this spiralled solid torus. More...
Perm< 4 > | vertexRoles (size_t index) const
| Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus. More...
void | reverse ()
| Reverses this spiralled solid torus. More...
void | cycle (size_t k)
| Cycles this spiralled solid torus by the given number of tetrahedra. More...
bool | makeCanonical (const Triangulation< 3 > *tri)
| Converts this spiralled solid torus into its canonical representation. More...
bool | isCanonical (const Triangulation< 3 > *tri) const
| Determines whether this spiralled solid torus is in canonical form. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static SpiralSolidTorus * | formsSpiralSolidTorus (Tetrahedron< 3 > *tet, Perm< 4 > useVertexRoles)
| Determines if the given tetrahedron forms part of a spiralled solid torus with its vertices playing the given roles in the solid torus. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Represents a spiralled solid torus in a triangulation.

A spiralled solid torus is created by placing tetrahedra one upon another in a spiralling fashion to form a giant loop.

For each tetrahedron, label the vertices A, B, C and D. Draw the tetrahedron so that the vertices form an upward spiral in the order A-B-C-D, with D directly above A. Face BCD is on the top, face ABC is on the bottom and faces ABD and ACD are both vertical.

When joining two tetrahedra, face BCD of the lower tetrahedron will be joined to face ABC of the upper tetrahedron. In this way the tetrahedra are placed one upon another to form a giant loop (which is closed up by placing the bottommost tetrahedron above the topmost tetrahedron in a similar fashion), forming a solid torus overall.

In each tetrahedron, directed edges AB, BC and CD are major edges, directed edges AC and BD are minor edges and directed edge AD is an axis edge.

The major edges all combined form a single longitude of the solid torus. Using this directed longitude, using the directed meridinal curve ACBA and assuming the spiralled solid torus contains n tetrahedra, the minor edges all combined form a (2, n) curve and the axis edges all combined form a (3, n) curve on the torus boundary.

Note that all tetrahedra in the spiralled solid torus must be distinct and there must be at least one tetrahedron.

Note also that class TriSolidTorus represents a spiralled solid torus with precisely three tetrahedra. A spiralled solid torus with only one tetrahedron is in fact a (1,2,3) layered solid torus.

All optional StandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

## ~SpiralSolidTorus()

regina::SpiralSolidTorus::~SpiralSolidTorus | ( |  | ) |

inline virtual

Destroys this spiralled solid torus.

## Member Function Documentation

## clone()

SpiralSolidTorus* regina::SpiralSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

## cycle()

void regina::SpiralSolidTorus::cycle | ( | size_t | k | ) |

Cycles this spiralled solid torus by the given number of tetrahedra.

Tetrahedra k, k+1, k+2 and so on will become tetrahedra 0, 1, 2 and so on respectively. Note that this operation will not change the vertex roles.

The underlying triangulation is not changed; all that changes is how this spiralled solid torus is represented.

Parameters

  k | the number of tetrahedra through which we should cycle.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## formsSpiralSolidTorus()

static SpiralSolidTorus* regina::SpiralSolidTorus::formsSpiralSolidTorus | ( | Tetrahedron< 3 > * | tet,
|  | Perm< 4 > | useVertexRoles
| ) |  |

static

Determines if the given tetrahedron forms part of a spiralled solid torus with its vertices playing the given roles in the solid torus.

Note that the boundary triangles of the spiralled solid torus need not be boundary triangles within the overall triangulation, i.e., they may be identified with each other or with triangles of other tetrahedra.

Parameters

  tet | the tetrahedron to examine.
  useVertexRoles | a permutation describing the role each tetrahedron vertex must play in the solid torus; this must be in the same format as the permutation returned by vertexRoles().

Returns
  a newly created structure containing details of the solid torus with the given tetrahedron as tetrahedron 0, or `null` if the given tetrahedron is not part of a spiralled solid torus with the given vertex roles.

## homology()

AbelianGroup* regina::SpiralSolidTorus::homology | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::StandardTriangulation.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## isCanonical()

bool regina::SpiralSolidTorus::isCanonical | ( | const Triangulation< 3 > * | tri | ) | const

Determines whether this spiralled solid torus is in canonical form.

Canonical form is described in detail in the description for makeCanonical().

Parameters

  tri | the triangulation in which this solid torus lives.

Returns
  `true` if and only if this spiralled solid torus is in canonical form.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## makeCanonical()

bool regina::SpiralSolidTorus::makeCanonical | ( | const Triangulation< 3 > * | tri | ) |

Converts this spiralled solid torus into its canonical representation.

The canonical representation of a spiralled solid torus is unique in a given triangulation.

Tetrahedron 0 in the spiralled solid torus will be the tetrahedron with the lowest index in the triangulation, and under permutation `vertexRoles(0)` the image of 0 will be less than the image of 3.

Parameters

  tri | the triangulation in which this solid torus lives.

Returns
  `true` if and only if the representation of this spiralled solid torus was actually changed.

## manifold()

Manifold* regina::SpiralSolidTorus::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## reverse()

void regina::SpiralSolidTorus::reverse | ( |  | ) |

Reverses this spiralled solid torus.

Tetrahedra 0, 1, 2, ..., size()-1 will become tetrahedra size()-1, ..., 2, 1, 0 respectively. Note that this operation will change the vertex roles as well.

The underlying triangulation is not changed; all that changes is how this spiralled solid torus is represented.

## size()

size_t regina::SpiralSolidTorus::size | ( |  | ) | const

inline

Returns the number of tetrahedra in this spiralled solid torus.

Returns
  the number of tetrahedra.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## tetrahedron()

Tetrahedron< 3 > * regina::SpiralSolidTorus::tetrahedron | ( | size_t | index | ) | const

inline

Returns the requested tetrahedron in this spiralled solid torus.

Tetrahedra are numbered from 0 to size()-1 inclusive, with tetrahedron i+1 being placed above tetrahedron i.

Parameters

  index | specifies which tetrahedron to return; this must be between 0 and size()-1 inclusive.

Returns
  the requested tetrahedron.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## vertexRoles()

Perm< 4 > regina::SpiralSolidTorus::vertexRoles | ( | size_t | index | ) | const

inline

Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus.

The permutation returned (call this `p`) maps 0, 1, 2 and 3 to the four vertices of tetrahedron index so that vertices `p[0]`, `p[1]`, `p[2]` and `p[3]` correspond to vertices A, B, C and D respectively as described in the general class notes.

In particular, the directed edge from vertex `p[0]` to `p[3]` is an axis edge, directed edges `p[0]` to `p[2]` and `p[1]` to `p[3]` are minor edges and the directed path from vertices `p[0]` to `p[1]` to `p[2]` to `p[3]` follows the three major edges.

See the general class notes for further details.

Parameters

  index | specifies which tetrahedron in the solid torus to examine; this must be between 0 and size()-1 inclusive.

Returns
  a permutation representing the roles of the vertices of the requested tetrahedron.

## writeName()

std::ostream & regina::SpiralSolidTorus::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream & regina::SpiralSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::SpiralSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::StandardTriangulation.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- subcomplex/spiralsolidtorus.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).